import winston from 'winston';
import { Router } from '../Router';
import { Server } from '../Server';
import { ControllerManager } from '../Controller';
import { ResponseManager } from '../Response/ResponseManager';
import { ConfigInterface } from '../Config';
export declare class Application {
    private config;
    private logger;
    private router;
    private server;
    private controllerManager;
    private responseManager;
    private moduleManager;
    constructor(config: ConfigInterface);
    private bootstrap;
    getLogger(): winston.Logger;
    getRouter(): Router;
    getServer(): Server;
    getControllerManager(): ControllerManager;
    getResponseManager(): ResponseManager;
    getConfig<T>(section: string): T;
    launch(): Promise<this>;
}
