"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = __importDefault(require("../../debug"));
const debug = debug_1.default('modules');
class ModuleManager {
    constructor(application, config) {
        this.application = application;
        this.config = config;
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            debug('Initializing');
            return yield this.loadModules(this.config);
        });
    }
    loadModule(ModuleClass) {
        return __awaiter(this, void 0, void 0, function* () {
            debug('Loading module ' + ModuleClass.name);
            const module = new ModuleClass(this.application);
            yield module.bootstrap();
            debug('Bootstrapped module ' + ModuleClass.name);
            return this;
        });
    }
    loadModules(config) {
        return __awaiter(this, void 0, void 0, function* () {
            debug('Loading modules');
            for (let i = 0; i < config.length; i++) {
                yield this.loadModule(config[i]);
            }
            debug('Loaded modules');
            return this;
        });
    }
}
exports.ModuleManager = ModuleManager;
//# sourceMappingURL=ModuleManager.js.map