import { HttpStatusCodes } from '../Server/HttpStatusCodes';
import { ContextInterface } from '../Interface';
export declare abstract class Response {
    abstract apply(): void;
    protected ctx: ContextInterface;
    protected headers: {
        [header: string]: string | Array<string>;
    };
    protected statusCode: HttpStatusCodes;
    protected meta: any;
    protected data: any;
    protected message: string;
    constructor({ message, data, meta, statusCode }: ResponseArgumentsInterface);
    patchContext(ctx: ContextInterface): void;
    setStatusCode(statusCode: HttpStatusCodes): this;
    getStatusCode(): HttpStatusCodes;
    setBody(body: any): this;
    setHeaders(headers: {
        [header: string]: string | Array<string>;
    }): this;
    addHeaders(headers: {
        [header: string]: string | Array<string>;
    }): this;
    setHeader(header: string, value: string | Array<string>): this;
    appendHeader(header: string, value: string | Array<string>): void;
    removeHeader(header: string): this;
    applyHeaders(): this;
}
export interface ResponseArgumentsInterface {
    statusCode: HttpStatusCodes;
    message?: string;
    data?: any;
    meta?: any;
}
