"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RequestMethods_1 = require("../Server/RequestMethods");
class Route {
    static method(method, route, controller, action) {
        return { method, route, controller, action };
    }
    static get(route, controller, action) {
        return Route.method(RequestMethods_1.RequestMethods.Get, route, controller, action);
    }
    static post(route, controller, action) {
        return Route.method(RequestMethods_1.RequestMethods.Post, route, controller, action);
    }
    static put(route, controller, action) {
        return Route.method(RequestMethods_1.RequestMethods.Put, route, controller, action);
    }
    static patch(route, controller, action) {
        return Route.method(RequestMethods_1.RequestMethods.Patch, route, controller, action);
    }
    static delete(route, controller, action) {
        return Route.method(RequestMethods_1.RequestMethods.Delete, route, controller, action);
    }
    static crud(route, controller) {
        const idRoute = `${route}/:id`;
        return [
            Route.post(route, controller, 'create'),
            Route.get(route, controller, 'find'),
            Route.get(idRoute, controller, 'findOne'),
            Route.put(idRoute, controller, 'overwrite'),
            Route.patch(idRoute, controller, 'update'),
            Route.delete(idRoute, controller, 'destroy'),
        ];
    }
}
exports.Route = Route;
//# sourceMappingURL=Route.js.map